# This an autogenerated file
# 
# Generated with AirFoilItem
from typing import Dict,Sequence,List
from dmt.entity import Entity
from dmt.blueprint import Blueprint
from .blueprints.airfoilitem import AirFoilItemBlueprint
from typing import Dict
from sima.sima.moao import MOAO
from sima.sima.scriptablevalue import ScriptableValue

class AirFoilItem(MOAO):
    """
    Keyword arguments
    -----------------
    name : str
         (default "")
    description : str
         (default "")
    _id : str
         (default "")
    scriptableValues : List[ScriptableValue]
    angle : float
         current angle-of-attack(default 0.0)
    cl : float
         Lift coefficient(default 0.0)
    cd : float
         Drag coefficient(default 0.0)
    cm : float
         Moment coefficient(default 0.0)
    """

    def __init__(self , name="", description="", _id="", angle=0.0, cl=0.0, cd=0.0, cm=0.0, **kwargs):
        super().__init__(**kwargs)
        self.name = name
        self.description = description
        self._id = _id
        self.scriptableValues = list()
        self.angle = angle
        self.cl = cl
        self.cd = cd
        self.cm = cm
        for key, value in kwargs.items():
            if not isinstance(value, Dict):
                setattr(self, key, value)


    @property
    def blueprint(self) -> Blueprint:
        """Return blueprint that this entity represents"""
        return AirFoilItemBlueprint()


    @property
    def name(self) -> str:
        """"""
        return self.__name

    @name.setter
    def name(self, value: str):
        """Set name"""
        self.__name = str(value)

    @property
    def description(self) -> str:
        """"""
        return self.__description

    @description.setter
    def description(self, value: str):
        """Set description"""
        self.__description = str(value)

    @property
    def _id(self) -> str:
        """"""
        return self.___id

    @_id.setter
    def _id(self, value: str):
        """Set _id"""
        self.___id = str(value)

    @property
    def scriptableValues(self) -> List[ScriptableValue]:
        """"""
        return self.__scriptableValues

    @scriptableValues.setter
    def scriptableValues(self, value: List[ScriptableValue]):
        """Set scriptableValues"""
        if not isinstance(value, Sequence):
            raise Exception("Expected sequense, but was " , type(value))
        self.__scriptableValues = value

    @property
    def angle(self) -> float:
        """current angle-of-attack"""
        return self.__angle

    @angle.setter
    def angle(self, value: float):
        """Set angle"""
        self.__angle = float(value)

    @property
    def cl(self) -> float:
        """Lift coefficient"""
        return self.__cl

    @cl.setter
    def cl(self, value: float):
        """Set cl"""
        self.__cl = float(value)

    @property
    def cd(self) -> float:
        """Drag coefficient"""
        return self.__cd

    @cd.setter
    def cd(self, value: float):
        """Set cd"""
        self.__cd = float(value)

    @property
    def cm(self) -> float:
        """Moment coefficient"""
        return self.__cm

    @cm.setter
    def cm(self, value: float):
        """Set cm"""
        self.__cm = float(value)
